import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import { AttachInstancesCommandInput, AttachInstancesCommandOutput } from "../commands/AttachInstancesCommand";
import { AttachLoadBalancersCommandInput, AttachLoadBalancersCommandOutput } from "../commands/AttachLoadBalancersCommand";
import { AttachLoadBalancerTargetGroupsCommandInput, AttachLoadBalancerTargetGroupsCommandOutput } from "../commands/AttachLoadBalancerTargetGroupsCommand";
import { AttachTrafficSourcesCommandInput, AttachTrafficSourcesCommandOutput } from "../commands/AttachTrafficSourcesCommand";
import { BatchDeleteScheduledActionCommandInput, BatchDeleteScheduledActionCommandOutput } from "../commands/BatchDeleteScheduledActionCommand";
import { BatchPutScheduledUpdateGroupActionCommandInput, BatchPutScheduledUpdateGroupActionCommandOutput } from "../commands/BatchPutScheduledUpdateGroupActionCommand";
import { CancelInstanceRefreshCommandInput, CancelInstanceRefreshCommandOutput } from "../commands/CancelInstanceRefreshCommand";
import { CompleteLifecycleActionCommandInput, CompleteLifecycleActionCommandOutput } from "../commands/CompleteLifecycleActionCommand";
import { CreateAutoScalingGroupCommandInput, CreateAutoScalingGroupCommandOutput } from "../commands/CreateAutoScalingGroupCommand";
import { CreateLaunchConfigurationCommandInput, CreateLaunchConfigurationCommandOutput } from "../commands/CreateLaunchConfigurationCommand";
import { CreateOrUpdateTagsCommandInput, CreateOrUpdateTagsCommandOutput } from "../commands/CreateOrUpdateTagsCommand";
import { DeleteAutoScalingGroupCommandInput, DeleteAutoScalingGroupCommandOutput } from "../commands/DeleteAutoScalingGroupCommand";
import { DeleteLaunchConfigurationCommandInput, DeleteLaunchConfigurationCommandOutput } from "../commands/DeleteLaunchConfigurationCommand";
import { DeleteLifecycleHookCommandInput, DeleteLifecycleHookCommandOutput } from "../commands/DeleteLifecycleHookCommand";
import { DeleteNotificationConfigurationCommandInput, DeleteNotificationConfigurationCommandOutput } from "../commands/DeleteNotificationConfigurationCommand";
import { DeletePolicyCommandInput, DeletePolicyCommandOutput } from "../commands/DeletePolicyCommand";
import { DeleteScheduledActionCommandInput, DeleteScheduledActionCommandOutput } from "../commands/DeleteScheduledActionCommand";
import { DeleteTagsCommandInput, DeleteTagsCommandOutput } from "../commands/DeleteTagsCommand";
import { DeleteWarmPoolCommandInput, DeleteWarmPoolCommandOutput } from "../commands/DeleteWarmPoolCommand";
import { DescribeAccountLimitsCommandInput, DescribeAccountLimitsCommandOutput } from "../commands/DescribeAccountLimitsCommand";
import { DescribeAdjustmentTypesCommandInput, DescribeAdjustmentTypesCommandOutput } from "../commands/DescribeAdjustmentTypesCommand";
import { DescribeAutoScalingGroupsCommandInput, DescribeAutoScalingGroupsCommandOutput } from "../commands/DescribeAutoScalingGroupsCommand";
import { DescribeAutoScalingInstancesCommandInput, DescribeAutoScalingInstancesCommandOutput } from "../commands/DescribeAutoScalingInstancesCommand";
import { DescribeAutoScalingNotificationTypesCommandInput, DescribeAutoScalingNotificationTypesCommandOutput } from "../commands/DescribeAutoScalingNotificationTypesCommand";
import { DescribeInstanceRefreshesCommandInput, DescribeInstanceRefreshesCommandOutput } from "../commands/DescribeInstanceRefreshesCommand";
import { DescribeLaunchConfigurationsCommandInput, DescribeLaunchConfigurationsCommandOutput } from "../commands/DescribeLaunchConfigurationsCommand";
import { DescribeLifecycleHooksCommandInput, DescribeLifecycleHooksCommandOutput } from "../commands/DescribeLifecycleHooksCommand";
import { DescribeLifecycleHookTypesCommandInput, DescribeLifecycleHookTypesCommandOutput } from "../commands/DescribeLifecycleHookTypesCommand";
import { DescribeLoadBalancersCommandInput, DescribeLoadBalancersCommandOutput } from "../commands/DescribeLoadBalancersCommand";
import { DescribeLoadBalancerTargetGroupsCommandInput, DescribeLoadBalancerTargetGroupsCommandOutput } from "../commands/DescribeLoadBalancerTargetGroupsCommand";
import { DescribeMetricCollectionTypesCommandInput, DescribeMetricCollectionTypesCommandOutput } from "../commands/DescribeMetricCollectionTypesCommand";
import { DescribeNotificationConfigurationsCommandInput, DescribeNotificationConfigurationsCommandOutput } from "../commands/DescribeNotificationConfigurationsCommand";
import { DescribePoliciesCommandInput, DescribePoliciesCommandOutput } from "../commands/DescribePoliciesCommand";
import { DescribeScalingActivitiesCommandInput, DescribeScalingActivitiesCommandOutput } from "../commands/DescribeScalingActivitiesCommand";
import { DescribeScalingProcessTypesCommandInput, DescribeScalingProcessTypesCommandOutput } from "../commands/DescribeScalingProcessTypesCommand";
import { DescribeScheduledActionsCommandInput, DescribeScheduledActionsCommandOutput } from "../commands/DescribeScheduledActionsCommand";
import { DescribeTagsCommandInput, DescribeTagsCommandOutput } from "../commands/DescribeTagsCommand";
import { DescribeTerminationPolicyTypesCommandInput, DescribeTerminationPolicyTypesCommandOutput } from "../commands/DescribeTerminationPolicyTypesCommand";
import { DescribeTrafficSourcesCommandInput, DescribeTrafficSourcesCommandOutput } from "../commands/DescribeTrafficSourcesCommand";
import { DescribeWarmPoolCommandInput, DescribeWarmPoolCommandOutput } from "../commands/DescribeWarmPoolCommand";
import { DetachInstancesCommandInput, DetachInstancesCommandOutput } from "../commands/DetachInstancesCommand";
import { DetachLoadBalancersCommandInput, DetachLoadBalancersCommandOutput } from "../commands/DetachLoadBalancersCommand";
import { DetachLoadBalancerTargetGroupsCommandInput, DetachLoadBalancerTargetGroupsCommandOutput } from "../commands/DetachLoadBalancerTargetGroupsCommand";
import { DetachTrafficSourcesCommandInput, DetachTrafficSourcesCommandOutput } from "../commands/DetachTrafficSourcesCommand";
import { DisableMetricsCollectionCommandInput, DisableMetricsCollectionCommandOutput } from "../commands/DisableMetricsCollectionCommand";
import { EnableMetricsCollectionCommandInput, EnableMetricsCollectionCommandOutput } from "../commands/EnableMetricsCollectionCommand";
import { EnterStandbyCommandInput, EnterStandbyCommandOutput } from "../commands/EnterStandbyCommand";
import { ExecutePolicyCommandInput, ExecutePolicyCommandOutput } from "../commands/ExecutePolicyCommand";
import { ExitStandbyCommandInput, ExitStandbyCommandOutput } from "../commands/ExitStandbyCommand";
import { GetPredictiveScalingForecastCommandInput, GetPredictiveScalingForecastCommandOutput } from "../commands/GetPredictiveScalingForecastCommand";
import { PutLifecycleHookCommandInput, PutLifecycleHookCommandOutput } from "../commands/PutLifecycleHookCommand";
import { PutNotificationConfigurationCommandInput, PutNotificationConfigurationCommandOutput } from "../commands/PutNotificationConfigurationCommand";
import { PutScalingPolicyCommandInput, PutScalingPolicyCommandOutput } from "../commands/PutScalingPolicyCommand";
import { PutScheduledUpdateGroupActionCommandInput, PutScheduledUpdateGroupActionCommandOutput } from "../commands/PutScheduledUpdateGroupActionCommand";
import { PutWarmPoolCommandInput, PutWarmPoolCommandOutput } from "../commands/PutWarmPoolCommand";
import { RecordLifecycleActionHeartbeatCommandInput, RecordLifecycleActionHeartbeatCommandOutput } from "../commands/RecordLifecycleActionHeartbeatCommand";
import { ResumeProcessesCommandInput, ResumeProcessesCommandOutput } from "../commands/ResumeProcessesCommand";
import { RollbackInstanceRefreshCommandInput, RollbackInstanceRefreshCommandOutput } from "../commands/RollbackInstanceRefreshCommand";
import { SetDesiredCapacityCommandInput, SetDesiredCapacityCommandOutput } from "../commands/SetDesiredCapacityCommand";
import { SetInstanceHealthCommandInput, SetInstanceHealthCommandOutput } from "../commands/SetInstanceHealthCommand";
import { SetInstanceProtectionCommandInput, SetInstanceProtectionCommandOutput } from "../commands/SetInstanceProtectionCommand";
import { StartInstanceRefreshCommandInput, StartInstanceRefreshCommandOutput } from "../commands/StartInstanceRefreshCommand";
import { SuspendProcessesCommandInput, SuspendProcessesCommandOutput } from "../commands/SuspendProcessesCommand";
import { TerminateInstanceInAutoScalingGroupCommandInput, TerminateInstanceInAutoScalingGroupCommandOutput } from "../commands/TerminateInstanceInAutoScalingGroupCommand";
import { UpdateAutoScalingGroupCommandInput, UpdateAutoScalingGroupCommandOutput } from "../commands/UpdateAutoScalingGroupCommand";
/**
 * serializeAws_queryAttachInstancesCommand
 */
export declare const se_AttachInstancesCommand: (input: AttachInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryAttachLoadBalancersCommand
 */
export declare const se_AttachLoadBalancersCommand: (input: AttachLoadBalancersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryAttachLoadBalancerTargetGroupsCommand
 */
export declare const se_AttachLoadBalancerTargetGroupsCommand: (input: AttachLoadBalancerTargetGroupsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryAttachTrafficSourcesCommand
 */
export declare const se_AttachTrafficSourcesCommand: (input: AttachTrafficSourcesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryBatchDeleteScheduledActionCommand
 */
export declare const se_BatchDeleteScheduledActionCommand: (input: BatchDeleteScheduledActionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryBatchPutScheduledUpdateGroupActionCommand
 */
export declare const se_BatchPutScheduledUpdateGroupActionCommand: (input: BatchPutScheduledUpdateGroupActionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryCancelInstanceRefreshCommand
 */
export declare const se_CancelInstanceRefreshCommand: (input: CancelInstanceRefreshCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryCompleteLifecycleActionCommand
 */
export declare const se_CompleteLifecycleActionCommand: (input: CompleteLifecycleActionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryCreateAutoScalingGroupCommand
 */
export declare const se_CreateAutoScalingGroupCommand: (input: CreateAutoScalingGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryCreateLaunchConfigurationCommand
 */
export declare const se_CreateLaunchConfigurationCommand: (input: CreateLaunchConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryCreateOrUpdateTagsCommand
 */
export declare const se_CreateOrUpdateTagsCommand: (input: CreateOrUpdateTagsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDeleteAutoScalingGroupCommand
 */
export declare const se_DeleteAutoScalingGroupCommand: (input: DeleteAutoScalingGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDeleteLaunchConfigurationCommand
 */
export declare const se_DeleteLaunchConfigurationCommand: (input: DeleteLaunchConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDeleteLifecycleHookCommand
 */
export declare const se_DeleteLifecycleHookCommand: (input: DeleteLifecycleHookCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDeleteNotificationConfigurationCommand
 */
export declare const se_DeleteNotificationConfigurationCommand: (input: DeleteNotificationConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDeletePolicyCommand
 */
export declare const se_DeletePolicyCommand: (input: DeletePolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDeleteScheduledActionCommand
 */
export declare const se_DeleteScheduledActionCommand: (input: DeleteScheduledActionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDeleteTagsCommand
 */
export declare const se_DeleteTagsCommand: (input: DeleteTagsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDeleteWarmPoolCommand
 */
export declare const se_DeleteWarmPoolCommand: (input: DeleteWarmPoolCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeAccountLimitsCommand
 */
export declare const se_DescribeAccountLimitsCommand: (input: DescribeAccountLimitsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeAdjustmentTypesCommand
 */
export declare const se_DescribeAdjustmentTypesCommand: (input: DescribeAdjustmentTypesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeAutoScalingGroupsCommand
 */
export declare const se_DescribeAutoScalingGroupsCommand: (input: DescribeAutoScalingGroupsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeAutoScalingInstancesCommand
 */
export declare const se_DescribeAutoScalingInstancesCommand: (input: DescribeAutoScalingInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeAutoScalingNotificationTypesCommand
 */
export declare const se_DescribeAutoScalingNotificationTypesCommand: (input: DescribeAutoScalingNotificationTypesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeInstanceRefreshesCommand
 */
export declare const se_DescribeInstanceRefreshesCommand: (input: DescribeInstanceRefreshesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeLaunchConfigurationsCommand
 */
export declare const se_DescribeLaunchConfigurationsCommand: (input: DescribeLaunchConfigurationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeLifecycleHooksCommand
 */
export declare const se_DescribeLifecycleHooksCommand: (input: DescribeLifecycleHooksCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeLifecycleHookTypesCommand
 */
export declare const se_DescribeLifecycleHookTypesCommand: (input: DescribeLifecycleHookTypesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeLoadBalancersCommand
 */
export declare const se_DescribeLoadBalancersCommand: (input: DescribeLoadBalancersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeLoadBalancerTargetGroupsCommand
 */
export declare const se_DescribeLoadBalancerTargetGroupsCommand: (input: DescribeLoadBalancerTargetGroupsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeMetricCollectionTypesCommand
 */
export declare const se_DescribeMetricCollectionTypesCommand: (input: DescribeMetricCollectionTypesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeNotificationConfigurationsCommand
 */
export declare const se_DescribeNotificationConfigurationsCommand: (input: DescribeNotificationConfigurationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribePoliciesCommand
 */
export declare const se_DescribePoliciesCommand: (input: DescribePoliciesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeScalingActivitiesCommand
 */
export declare const se_DescribeScalingActivitiesCommand: (input: DescribeScalingActivitiesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeScalingProcessTypesCommand
 */
export declare const se_DescribeScalingProcessTypesCommand: (input: DescribeScalingProcessTypesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeScheduledActionsCommand
 */
export declare const se_DescribeScheduledActionsCommand: (input: DescribeScheduledActionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeTagsCommand
 */
export declare const se_DescribeTagsCommand: (input: DescribeTagsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeTerminationPolicyTypesCommand
 */
export declare const se_DescribeTerminationPolicyTypesCommand: (input: DescribeTerminationPolicyTypesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeTrafficSourcesCommand
 */
export declare const se_DescribeTrafficSourcesCommand: (input: DescribeTrafficSourcesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDescribeWarmPoolCommand
 */
export declare const se_DescribeWarmPoolCommand: (input: DescribeWarmPoolCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDetachInstancesCommand
 */
export declare const se_DetachInstancesCommand: (input: DetachInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDetachLoadBalancersCommand
 */
export declare const se_DetachLoadBalancersCommand: (input: DetachLoadBalancersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDetachLoadBalancerTargetGroupsCommand
 */
export declare const se_DetachLoadBalancerTargetGroupsCommand: (input: DetachLoadBalancerTargetGroupsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDetachTrafficSourcesCommand
 */
export declare const se_DetachTrafficSourcesCommand: (input: DetachTrafficSourcesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryDisableMetricsCollectionCommand
 */
export declare const se_DisableMetricsCollectionCommand: (input: DisableMetricsCollectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryEnableMetricsCollectionCommand
 */
export declare const se_EnableMetricsCollectionCommand: (input: EnableMetricsCollectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryEnterStandbyCommand
 */
export declare const se_EnterStandbyCommand: (input: EnterStandbyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryExecutePolicyCommand
 */
export declare const se_ExecutePolicyCommand: (input: ExecutePolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryExitStandbyCommand
 */
export declare const se_ExitStandbyCommand: (input: ExitStandbyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryGetPredictiveScalingForecastCommand
 */
export declare const se_GetPredictiveScalingForecastCommand: (input: GetPredictiveScalingForecastCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryPutLifecycleHookCommand
 */
export declare const se_PutLifecycleHookCommand: (input: PutLifecycleHookCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryPutNotificationConfigurationCommand
 */
export declare const se_PutNotificationConfigurationCommand: (input: PutNotificationConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryPutScalingPolicyCommand
 */
export declare const se_PutScalingPolicyCommand: (input: PutScalingPolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryPutScheduledUpdateGroupActionCommand
 */
export declare const se_PutScheduledUpdateGroupActionCommand: (input: PutScheduledUpdateGroupActionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryPutWarmPoolCommand
 */
export declare const se_PutWarmPoolCommand: (input: PutWarmPoolCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryRecordLifecycleActionHeartbeatCommand
 */
export declare const se_RecordLifecycleActionHeartbeatCommand: (input: RecordLifecycleActionHeartbeatCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryResumeProcessesCommand
 */
export declare const se_ResumeProcessesCommand: (input: ResumeProcessesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryRollbackInstanceRefreshCommand
 */
export declare const se_RollbackInstanceRefreshCommand: (input: RollbackInstanceRefreshCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_querySetDesiredCapacityCommand
 */
export declare const se_SetDesiredCapacityCommand: (input: SetDesiredCapacityCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_querySetInstanceHealthCommand
 */
export declare const se_SetInstanceHealthCommand: (input: SetInstanceHealthCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_querySetInstanceProtectionCommand
 */
export declare const se_SetInstanceProtectionCommand: (input: SetInstanceProtectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryStartInstanceRefreshCommand
 */
export declare const se_StartInstanceRefreshCommand: (input: StartInstanceRefreshCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_querySuspendProcessesCommand
 */
export declare const se_SuspendProcessesCommand: (input: SuspendProcessesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryTerminateInstanceInAutoScalingGroupCommand
 */
export declare const se_TerminateInstanceInAutoScalingGroupCommand: (input: TerminateInstanceInAutoScalingGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_queryUpdateAutoScalingGroupCommand
 */
export declare const se_UpdateAutoScalingGroupCommand: (input: UpdateAutoScalingGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * deserializeAws_queryAttachInstancesCommand
 */
export declare const de_AttachInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AttachInstancesCommandOutput>;
/**
 * deserializeAws_queryAttachLoadBalancersCommand
 */
export declare const de_AttachLoadBalancersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AttachLoadBalancersCommandOutput>;
/**
 * deserializeAws_queryAttachLoadBalancerTargetGroupsCommand
 */
export declare const de_AttachLoadBalancerTargetGroupsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AttachLoadBalancerTargetGroupsCommandOutput>;
/**
 * deserializeAws_queryAttachTrafficSourcesCommand
 */
export declare const de_AttachTrafficSourcesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AttachTrafficSourcesCommandOutput>;
/**
 * deserializeAws_queryBatchDeleteScheduledActionCommand
 */
export declare const de_BatchDeleteScheduledActionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchDeleteScheduledActionCommandOutput>;
/**
 * deserializeAws_queryBatchPutScheduledUpdateGroupActionCommand
 */
export declare const de_BatchPutScheduledUpdateGroupActionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchPutScheduledUpdateGroupActionCommandOutput>;
/**
 * deserializeAws_queryCancelInstanceRefreshCommand
 */
export declare const de_CancelInstanceRefreshCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CancelInstanceRefreshCommandOutput>;
/**
 * deserializeAws_queryCompleteLifecycleActionCommand
 */
export declare const de_CompleteLifecycleActionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CompleteLifecycleActionCommandOutput>;
/**
 * deserializeAws_queryCreateAutoScalingGroupCommand
 */
export declare const de_CreateAutoScalingGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateAutoScalingGroupCommandOutput>;
/**
 * deserializeAws_queryCreateLaunchConfigurationCommand
 */
export declare const de_CreateLaunchConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateLaunchConfigurationCommandOutput>;
/**
 * deserializeAws_queryCreateOrUpdateTagsCommand
 */
export declare const de_CreateOrUpdateTagsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateOrUpdateTagsCommandOutput>;
/**
 * deserializeAws_queryDeleteAutoScalingGroupCommand
 */
export declare const de_DeleteAutoScalingGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteAutoScalingGroupCommandOutput>;
/**
 * deserializeAws_queryDeleteLaunchConfigurationCommand
 */
export declare const de_DeleteLaunchConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteLaunchConfigurationCommandOutput>;
/**
 * deserializeAws_queryDeleteLifecycleHookCommand
 */
export declare const de_DeleteLifecycleHookCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteLifecycleHookCommandOutput>;
/**
 * deserializeAws_queryDeleteNotificationConfigurationCommand
 */
export declare const de_DeleteNotificationConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteNotificationConfigurationCommandOutput>;
/**
 * deserializeAws_queryDeletePolicyCommand
 */
export declare const de_DeletePolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeletePolicyCommandOutput>;
/**
 * deserializeAws_queryDeleteScheduledActionCommand
 */
export declare const de_DeleteScheduledActionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteScheduledActionCommandOutput>;
/**
 * deserializeAws_queryDeleteTagsCommand
 */
export declare const de_DeleteTagsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTagsCommandOutput>;
/**
 * deserializeAws_queryDeleteWarmPoolCommand
 */
export declare const de_DeleteWarmPoolCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteWarmPoolCommandOutput>;
/**
 * deserializeAws_queryDescribeAccountLimitsCommand
 */
export declare const de_DescribeAccountLimitsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeAccountLimitsCommandOutput>;
/**
 * deserializeAws_queryDescribeAdjustmentTypesCommand
 */
export declare const de_DescribeAdjustmentTypesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeAdjustmentTypesCommandOutput>;
/**
 * deserializeAws_queryDescribeAutoScalingGroupsCommand
 */
export declare const de_DescribeAutoScalingGroupsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeAutoScalingGroupsCommandOutput>;
/**
 * deserializeAws_queryDescribeAutoScalingInstancesCommand
 */
export declare const de_DescribeAutoScalingInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeAutoScalingInstancesCommandOutput>;
/**
 * deserializeAws_queryDescribeAutoScalingNotificationTypesCommand
 */
export declare const de_DescribeAutoScalingNotificationTypesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeAutoScalingNotificationTypesCommandOutput>;
/**
 * deserializeAws_queryDescribeInstanceRefreshesCommand
 */
export declare const de_DescribeInstanceRefreshesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeInstanceRefreshesCommandOutput>;
/**
 * deserializeAws_queryDescribeLaunchConfigurationsCommand
 */
export declare const de_DescribeLaunchConfigurationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeLaunchConfigurationsCommandOutput>;
/**
 * deserializeAws_queryDescribeLifecycleHooksCommand
 */
export declare const de_DescribeLifecycleHooksCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeLifecycleHooksCommandOutput>;
/**
 * deserializeAws_queryDescribeLifecycleHookTypesCommand
 */
export declare const de_DescribeLifecycleHookTypesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeLifecycleHookTypesCommandOutput>;
/**
 * deserializeAws_queryDescribeLoadBalancersCommand
 */
export declare const de_DescribeLoadBalancersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeLoadBalancersCommandOutput>;
/**
 * deserializeAws_queryDescribeLoadBalancerTargetGroupsCommand
 */
export declare const de_DescribeLoadBalancerTargetGroupsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeLoadBalancerTargetGroupsCommandOutput>;
/**
 * deserializeAws_queryDescribeMetricCollectionTypesCommand
 */
export declare const de_DescribeMetricCollectionTypesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeMetricCollectionTypesCommandOutput>;
/**
 * deserializeAws_queryDescribeNotificationConfigurationsCommand
 */
export declare const de_DescribeNotificationConfigurationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeNotificationConfigurationsCommandOutput>;
/**
 * deserializeAws_queryDescribePoliciesCommand
 */
export declare const de_DescribePoliciesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribePoliciesCommandOutput>;
/**
 * deserializeAws_queryDescribeScalingActivitiesCommand
 */
export declare const de_DescribeScalingActivitiesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeScalingActivitiesCommandOutput>;
/**
 * deserializeAws_queryDescribeScalingProcessTypesCommand
 */
export declare const de_DescribeScalingProcessTypesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeScalingProcessTypesCommandOutput>;
/**
 * deserializeAws_queryDescribeScheduledActionsCommand
 */
export declare const de_DescribeScheduledActionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeScheduledActionsCommandOutput>;
/**
 * deserializeAws_queryDescribeTagsCommand
 */
export declare const de_DescribeTagsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTagsCommandOutput>;
/**
 * deserializeAws_queryDescribeTerminationPolicyTypesCommand
 */
export declare const de_DescribeTerminationPolicyTypesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTerminationPolicyTypesCommandOutput>;
/**
 * deserializeAws_queryDescribeTrafficSourcesCommand
 */
export declare const de_DescribeTrafficSourcesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTrafficSourcesCommandOutput>;
/**
 * deserializeAws_queryDescribeWarmPoolCommand
 */
export declare const de_DescribeWarmPoolCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeWarmPoolCommandOutput>;
/**
 * deserializeAws_queryDetachInstancesCommand
 */
export declare const de_DetachInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DetachInstancesCommandOutput>;
/**
 * deserializeAws_queryDetachLoadBalancersCommand
 */
export declare const de_DetachLoadBalancersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DetachLoadBalancersCommandOutput>;
/**
 * deserializeAws_queryDetachLoadBalancerTargetGroupsCommand
 */
export declare const de_DetachLoadBalancerTargetGroupsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DetachLoadBalancerTargetGroupsCommandOutput>;
/**
 * deserializeAws_queryDetachTrafficSourcesCommand
 */
export declare const de_DetachTrafficSourcesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DetachTrafficSourcesCommandOutput>;
/**
 * deserializeAws_queryDisableMetricsCollectionCommand
 */
export declare const de_DisableMetricsCollectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableMetricsCollectionCommandOutput>;
/**
 * deserializeAws_queryEnableMetricsCollectionCommand
 */
export declare const de_EnableMetricsCollectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableMetricsCollectionCommandOutput>;
/**
 * deserializeAws_queryEnterStandbyCommand
 */
export declare const de_EnterStandbyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnterStandbyCommandOutput>;
/**
 * deserializeAws_queryExecutePolicyCommand
 */
export declare const de_ExecutePolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ExecutePolicyCommandOutput>;
/**
 * deserializeAws_queryExitStandbyCommand
 */
export declare const de_ExitStandbyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ExitStandbyCommandOutput>;
/**
 * deserializeAws_queryGetPredictiveScalingForecastCommand
 */
export declare const de_GetPredictiveScalingForecastCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetPredictiveScalingForecastCommandOutput>;
/**
 * deserializeAws_queryPutLifecycleHookCommand
 */
export declare const de_PutLifecycleHookCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutLifecycleHookCommandOutput>;
/**
 * deserializeAws_queryPutNotificationConfigurationCommand
 */
export declare const de_PutNotificationConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutNotificationConfigurationCommandOutput>;
/**
 * deserializeAws_queryPutScalingPolicyCommand
 */
export declare const de_PutScalingPolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutScalingPolicyCommandOutput>;
/**
 * deserializeAws_queryPutScheduledUpdateGroupActionCommand
 */
export declare const de_PutScheduledUpdateGroupActionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutScheduledUpdateGroupActionCommandOutput>;
/**
 * deserializeAws_queryPutWarmPoolCommand
 */
export declare const de_PutWarmPoolCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutWarmPoolCommandOutput>;
/**
 * deserializeAws_queryRecordLifecycleActionHeartbeatCommand
 */
export declare const de_RecordLifecycleActionHeartbeatCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RecordLifecycleActionHeartbeatCommandOutput>;
/**
 * deserializeAws_queryResumeProcessesCommand
 */
export declare const de_ResumeProcessesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ResumeProcessesCommandOutput>;
/**
 * deserializeAws_queryRollbackInstanceRefreshCommand
 */
export declare const de_RollbackInstanceRefreshCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RollbackInstanceRefreshCommandOutput>;
/**
 * deserializeAws_querySetDesiredCapacityCommand
 */
export declare const de_SetDesiredCapacityCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SetDesiredCapacityCommandOutput>;
/**
 * deserializeAws_querySetInstanceHealthCommand
 */
export declare const de_SetInstanceHealthCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SetInstanceHealthCommandOutput>;
/**
 * deserializeAws_querySetInstanceProtectionCommand
 */
export declare const de_SetInstanceProtectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SetInstanceProtectionCommandOutput>;
/**
 * deserializeAws_queryStartInstanceRefreshCommand
 */
export declare const de_StartInstanceRefreshCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartInstanceRefreshCommandOutput>;
/**
 * deserializeAws_querySuspendProcessesCommand
 */
export declare const de_SuspendProcessesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SuspendProcessesCommandOutput>;
/**
 * deserializeAws_queryTerminateInstanceInAutoScalingGroupCommand
 */
export declare const de_TerminateInstanceInAutoScalingGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TerminateInstanceInAutoScalingGroupCommandOutput>;
/**
 * deserializeAws_queryUpdateAutoScalingGroupCommand
 */
export declare const de_UpdateAutoScalingGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateAutoScalingGroupCommandOutput>;
